package com.drinkertea.test2smack;

import org.jivesoftware.smack.AbstractXMPPConnection;
import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.chat2.ChatManager;
import org.jivesoftware.smack.packet.Message;
import org.jivesoftware.smack.packet.Presence;
import org.jivesoftware.smack.roster.Roster;
import org.jivesoftware.smack.roster.RosterEntry;
import org.jivesoftware.smack.tcp.XMPPTCPConnection;
import org.jivesoftware.smack.tcp.XMPPTCPConnectionConfiguration;
import org.jivesoftware.smackx.mam.MamManager;
import org.jivesoftware.smackx.muc.HostedRoom;
import org.jivesoftware.smackx.muc.MultiUserChat;
import org.jivesoftware.smackx.muc.MultiUserChatManager;
import org.jxmpp.jid.DomainBareJid;
import org.jxmpp.jid.EntityBareJid;
import org.jxmpp.jid.EntityFullJid;
import org.jxmpp.jid.impl.JidCreate;
import org.jxmpp.jid.parts.Resourcepart;
import org.jxmpp.stringprep.XmppStringprepException;
import org.minidns.record.A;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

public class XMPPClass {

    public static ChatManager chatManager;
    public static AbstractXMPPConnection connection;
    public static Roster roster;
    public static EntityBareJid chatJid;
    public static EntityBareJid myJid;
    public static ArrayList<ChatItem> chatItems = new ArrayList<ChatItem>();
    public static List<Message> messages;
    public static MultiUserChatManager manager;
    public static List<MultiUserChat> listMuc = new ArrayList<>();
    public static MultiUserChat activeMuc;

    public static void XMPP_JoinRoom(String room_name, String nickname){
        try {
            EntityBareJid JIDRoom = JidCreate.entityBareFrom(room_name);
            MultiUserChat muc = manager.getMultiUserChat(JIDRoom);
            listMuc.add(muc);
            Resourcepart room  = Resourcepart.from(nickname);
            if(!muc.isJoined()){
                muc.join(room);
            }
            activeMuc = muc;
            for(EntityFullJid jid1 : muc.getOccupants()){
                System.out.println(jid1);
            }
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }

    }

    public static boolean XMPP_Connection(String login, String password) throws Exception{
        try {
            myJid = JidCreate.entityBareFrom(login + "@msg.sharix-app.org");
            XMPPTCPConnectionConfiguration config = XMPPTCPConnectionConfiguration.builder()
                    .setXmppDomain("msg.sharix-app.org")
                    .setHost("46.138.247.90")
                    .build();
            connection = new XMPPTCPConnection(config);
            connection.connect();
            connection.login(login, password);
            chatManager = ChatManager.getInstanceFor(connection);
            roster = Roster.getInstanceFor(connection);
            return true;
        }catch (Exception ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }

    public static void CreateChatListMessage(EntityBareJid jid, int message_count){
        try {
            MamManager mamManager = MamManager.getInstanceFor(connection);
            MamManager.MamQueryArgs mamQueryArgs = MamManager.MamQueryArgs.builder()
                    .limitResultsToJid(jid)
                    .setResultPageSizeTo(message_count)
                    .queryLastPage()
                    .build();
            MamManager.MamQuery mamQuery = mamManager.queryArchive(mamQueryArgs);
            messages = mamQuery.getMessages();
        }catch (Exception ex){
        }
    }

    public static List<Message> CreateRoomListMessage(int message_count, MultiUserChat muc_conn){
        try {
            MamManager mamManager = MamManager.getInstanceFor(muc_conn);
            MamManager.MamQueryArgs mamQueryArgs = MamManager.MamQueryArgs.builder()
                    .setResultPageSizeTo(message_count)
                    .queryLastPage()
                    .build();
            MamManager.MamQuery mamQuery = mamManager.queryArchive(mamQueryArgs);
            return mamQuery.getMessages();
        }catch (Exception ex){
            return null;
        }
    }

    public static List<EntityBareJid> GenerateRoomList() throws Exception{
        List<EntityBareJid> listRoom = new ArrayList<>();
        manager = MultiUserChatManager.getInstanceFor(XMPPClass.connection);
        List<DomainBareJid> domains = manager.getMucServiceDomains();
        for (DomainBareJid domain : domains){
            Map<EntityBareJid, HostedRoom> map = manager.getRoomsHostedBy(domain);
            for(EntityBareJid ent : map.keySet()){
                listRoom.add(ent);
                System.out.println(ent);
            }
        }
        return listRoom;
    }

    public static void GenerateChatList(){
        Collection<RosterEntry> entries = roster.getEntries();
        Presence presence;
        for (RosterEntry entry : entries){
            presence = roster.getPresence(entry.getJid());
            ChatItem chatItem = new ChatItem();
            chatItem.jid = presence.getFrom().asBareJid().toString().trim();

            if(entry.getName() != null){
                chatItem.name = entry.getName().trim();
            }
            else {
                chatItem.name = null;
            }

            if (presence.getType().toString().trim().equals("unavailable")){
                chatItem.status = "Offline";
            }
            else chatItem.status = "Online";

            chatItem.message = null;
            chatItems.add(chatItem);
        }
    }

}
