package com.drinkertea.test2smack;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import org.jivesoftware.smack.packet.Message;
import org.jivesoftware.smackx.muc.MultiUserChat;
import org.jxmpp.jid.EntityBareJid;

public class rooms extends AppCompatActivity {

    LinearLayout mainListRooms;

    @Override
    protected void onCreate(Bundle savedInstanceState)  {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_rooms);
        mainListRooms = (LinearLayout) findViewById(R.id.roomsListLayout);
        try {
            GenerateRoomsList();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public void GenerateRoomsList() throws Exception{
        for(EntityBareJid entity : XMPPClass.GenerateRoomList()){
            LinearLayout Container = new LinearLayout(this);
            TextView NameRoom = new TextView(this);
            TextView JIDRoom = new TextView(this);

            Container.setOrientation(LinearLayout.VERTICAL);
            Container.setBackgroundColor(Color.parseColor("#C0C0C0"));
            LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(
                    LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);

            layoutParams.setMargins(55, 15, 55, 15);
            Container.setPadding(15, 15, 15, 15);
            Container.setLayoutParams(layoutParams);

            NameRoom.setTextColor(Color.parseColor("#000000"));
            NameRoom.setText(entity.asBareJid().toString().split("@")[0].toUpperCase());

            JIDRoom.setText(entity.asBareJid().toString());

            Container.addView(NameRoom);
            Container.addView(JIDRoom);
            Container.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    XMPPClass.XMPP_JoinRoom(entity.asEntityBareJidString(), "Test Room User");
                    Intent intent = new Intent(rooms.this, Room.class);
                    startActivity(intent);
                }
            });

            mainListRooms.addView(Container);
        }
    }
}